package com.tmax.openframe.file;

import ch.obermuhlner.math.big.BigDecimalMath;
import com.tmax.openframe.dataset.*;
import com.tmax.openframe.variable.group.*;
import com.tmax.proobject.dataobject.exception.EmptyResultException;
import com.tmax.proobject.dataobject.session.SessionContainer;
import java.math.*;
import java.sql.SQLException;
import java.util.*;
import lombok.*;

/** 
 * <p>This source code was generated by COBOL to JAVA migrator</p>
 */
public class OIVPSAM_FD_IN_OIVPTEST_FILE {
    private Long currentSeqId = null;
    private static final int DEFAULT_FETCH_SIZE = 100;
    private OIVPDS_Dof dof;
    private @Getter FileStatus fileStatus;
    private Iterator<OIVPDS_Do> forwardListIterator_OIVPSAM_FD_IN_OIVPTEST_FILE;

    public OIVPSAM_FD_IN_OIVPTEST_FILE() {
        dof = new OIVPDS_Dof("tibero6_dev");
        forwardListIterator_OIVPSAM_FD_IN_OIVPTEST_FILE = null;
    }

    public void start(Long key) {
        currentSeqId = key;
        dof.setSeq_id(String.valueOf(currentSeqId));
        dof.setFullQuery(OIVPSAM_OIVPSAM_FD_IN_OIVPTEST_FILE_Dof.FULLQUERY.READ_GE);
        forwardListIterator_OIVPSAM_FD_IN_OIVPTEST_FILE = dof.getForwardList()
                .iterator();
        if (forwardListIterator_OIVPSAM_FD_IN_OIVPTEST_FILE.hasNext()) {
            fileStatus = FileStatus.INVALID_KEY_READ;
            return;
        }
        fileStatus = FileStatus.NORMAL;
    }

    public OIVPSAM_PEOPLE_INFO read() {
        if (fileStatus == FileStatus.AT_END_CONDITION_SEQUENCED) {
            fileStatus = FileStatus.ALREADY_AT_END_CONDITION;
            return null;
        }
        OIVPSAM_OIVPSAM_FD_IN_OIVPTEST_FILE_Do tmp = null;
        if (forwardListIterator_OIVPSAM_FD_IN_OIVPTEST_FILE != null) {
            if (forwardListIterator_OIVPSAM_FD_IN_OIVPTEST_FILE.hasNext()) {
                tmp = forwardListIterator_OIVPSAM_FD_IN_OIVPTEST_FILE.next();
                currentSeqId = tmp.getSEQ_ID();
            } else {
                fileStatus = FileStatus.AT_END_CONDITION_SEQUENCED;
                return null;
            }
        } else {
            dof.setFullQuery(OIVPSAM_OIVPSAM_FD_IN_OIVPTEST_FILE_Dof.FULLQUERY.READ_GE);
            dof.setSeq_id(String.valueOf(getNextSeqId()));
            forwardListIterator_OIVPSAM_FD_IN_OIVPTEST_FILE = dof
                    .getForwardList().iterator();
            if (forwardListIterator_OIVPSAM_FD_IN_OIVPTEST_FILE.hasNext()) {
                tmp = forwardListIterator_OIVPSAM_FD_IN_OIVPTEST_FILE.next();
                currentSeqId = tmp.getSEQ_ID();
            } else {
                fileStatus = FileStatus.AT_END_CONDITION_SEQUENCED;
                return null;
            }
        }
        fileStatus = FileStatus.NORMAL;
        return OIVPSAM_OIVPSAM_FD_IN_OIVPTEST_FILE_DoToOIVPSAM_PEOPLE_INFOMapper.INSTANCE
                .toOIVPSAM_PEOPLE_INFO(tmp);
    }

    public OIVPSAM_PEOPLE_INFO readNext() {
        return read();
    }

    public OIVPSAM_PEOPLE_INFO readKey(Long key) {
        currentSeqId = key;
        dof.setSeq_id(String.valueOf(currentSeqId));
        dof.setFullQuery(OIVPSAM_OIVPSAM_FD_IN_OIVPTEST_FILE_Dof.FULLQUERY.READ_EQ);
        forwardListIterator_OIVPSAM_FD_IN_OIVPTEST_FILE = dof.getForwardList()
                .iterator();
        OIVPSAM_PEOPLE_INFO record = read();
        if (record == null) {
            fileStatus = FileStatus.INVALID_KEY_READ;
            return null;
        }
        return record;
    }

    public void rewrite(OIVPSAM_PEOPLE_INFO data, Long seq) {
        OIVPSAM_OIVPSAM_FD_IN_OIVPTEST_FILE_Do tmpObject = OIVPSAM_OIVPSAM_FD_IN_OIVPTEST_FILE_DoToOIVPSAM_PEOPLE_INFOMapper.INSTANCE
                .toOIVPSAM_OIVPSAM_FD_IN_OIVPTEST_FILE_Do(data);
        dof.setFullQuery(OIVPSAM_OIVPSAM_FD_IN_OIVPTEST_FILE_Dof.FULLQUERY.REWRITE);
        tmpObject.setSEQ_ID(seq);
        try {
            dof.update(tmpObject);
            fileStatus = FileStatus.NORMAL;
        } catch (EmptyResultException ex) {
            fileStatus = FileStatus.INVALID_KEY_CREATE;
        }
    }

    public void rewrite(OIVPSAM_PEOPLE_INFO data) {
        rewrite(data, currentSeqId);
    }

    public void write(OIVPSAM_PEOPLE_INFO data) {
        dof.setFullQuery(OIVPSAM_OIVPSAM_FD_IN_OIVPTEST_FILE_Dof.FULLQUERY.WRITE);
        dof.add(OIVPSAM_OIVPSAM_FD_IN_OIVPTEST_FILE_DoToOIVPSAM_PEOPLE_INFOMapper.INSTANCE
                .toOIVPSAM_OIVPSAM_FD_IN_OIVPTEST_FILE_Do(data));
        fileStatus = FileStatus.NORMAL;
    }

    public int delete() {
        return _delete(currentSeqId);
    }

    public int delete(Long key) {
        int cnt = _delete(key);
        if (cnt == 0) {
            fileStatus = FileStatus.INVALID_KEY_READ;
        } else {
            fileStatus = FileStatus.NORMAL;
        }
        return cnt;
    }

    private int _delete(Long key) {
        if (dof == null
                || forwardListIterator_OIVPSAM_FD_IN_OIVPTEST_FILE == null) {
            return 0;
        }
        dof.setFullQuery(OIVPSAM_OIVPSAM_FD_IN_OIVPTEST_FILE_Dof.FULLQUERY.DELETE);
        dof.setSeq_id(String.valueOf(currentSeqId));
        return dof.remove();
    }

    public void close() {
        SessionContainer.getInstance().commit();
        forwardListIterator_OIVPSAM_FD_IN_OIVPTEST_FILE = null;
        currentSeqId = null;
    }

    private Long getNextSeqId() {
        if (currentSeqId != null) {
            currentSeqId++;
        } else {
            currentSeqId = 1L;
        }
        return currentSeqId;
    }
}
